/*
 *	main.c
 *
 *	Vvt[cX}bV
 *
 *	* Mon Aug 07 02:45:11 JST 2006 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_CHR
#define CHR_ CHR_INIT2
const CHR chr_tbl[] = {
#include "chr.h"
};
#undef CHR_
#endif /*USE_CHR*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	
 ****************************************************************************/

#define NUM_FRUIT_PATTERNS	9
static const short ptn_fruit[NUM_CELL_TYPES/*CELL.type-1*/][NUM_FRUIT_PATTERNS] = {
	{ CHR_FRUIT10,CHR_FRUIT11,CHR_FRUIT12,CHR_FRUIT13,CHR_FRUIT14,CHR_FRUIT15,CHR_FRUIT16,CHR_FRUIT17,CHR_FRUIT18 },
	{ CHR_FRUIT20,CHR_FRUIT21,CHR_FRUIT22,CHR_FRUIT23,CHR_FRUIT24,CHR_FRUIT25,CHR_FRUIT26,CHR_FRUIT27,CHR_FRUIT28 },
	{ CHR_FRUIT30,CHR_FRUIT31,CHR_FRUIT32,CHR_FRUIT33,CHR_FRUIT34,CHR_FRUIT35,CHR_FRUIT36,CHR_FRUIT37,CHR_FRUIT38 },
	{ CHR_FRUIT40,CHR_FRUIT41,CHR_FRUIT42,CHR_FRUIT43,CHR_FRUIT44,CHR_FRUIT45,CHR_FRUIT46,CHR_FRUIT47,CHR_FRUIT48 },
	{ CHR_FRUIT50,CHR_FRUIT51,CHR_FRUIT52,CHR_FRUIT53,CHR_FRUIT54,CHR_FRUIT55,CHR_FRUIT56,CHR_FRUIT57,CHR_FRUIT58 },
};

static const short ptn_point[10] = {
	CHR_POINTXX,CHR_POINT10,CHR_POINT20,CHR_POINT30,CHR_POINT40,CHR_POINT50,CHR_POINT60,CHR_POINT70,CHR_POINT80,CHR_POINT90,
};

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/*{{2007/07/23 P/EMU 48MHzΉΉ*/
	bP0_P0D_P07D = 1;
	/*}}2007/07/23 P/EMU 48MHzΉΉ*/

	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) {
			break;
		}
		game_main();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
#ifdef USE_MUSIC
	/* hFǂݍ݂܂B */
	{
		int retval;
		thread_lock();
		retval = loadInst();
		thread_unlock();
		if(retval != 0) {
			grcls(3);
			symbol(4, 34, "drum.arcǂݍݎsł", 0, 0);
			symbol(4, 44, "h͍Đ܂", 0, 0);
			wait(3000);
			grcls(-1);
		}
	}
#endif /*USE_MUSIC*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

	///* \ݒB */
	//dispmode(1,	/* 1:XvCg\/0:\ */
	//	 0,	/* 1:eLXg\/0:\ */
	//	 1,	/* 1:OtBbN\/0:\ */
	//	 0,	/* 1:eLXgO/0:w */
	//	 0);	/* wiF(wʕ\Ȃ̂) */
	//demo_main(),game_main()ɂČʂɐݒB

	/* V[hB */
	srand(pceTimerGetCount());
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned prev;
	       unsigned cur;
	int joy_old, trg;

#ifdef USE_PAUSE
	{
		int pause = 0;
		for(;;) {
#endif /*USE_PAUSE */

			/* [VSYNC҂B */
			if(prev == 0) prev = msec();
			do {
				cur = msec();
			} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
			prev = cur;

			/* pbhԎ擾B
			 * - VvCuł́AgK̔ōsKv܂B
			 */
			joy_old = joy;
			joy = pad() & 0x00ff;
			trg = (joy ^ joy_old) & joy;
			joy |= trg << 8;

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause; /* PAUSEԐ؂ւ */
				if(!pause) pausedisp(0);
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(msec() % 1000 < 750) {
				pausedisp(1);
			} else {
				pausedisp(0);
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	{
		static unsigned char rep[8]; /* I[gs[gJE^ */
		int i, mask;
		for(i = 0; i < 8; i++) {
			mask = 1 << i; /* PAD_* */
			if(QUICK_REPEAT_PADS & mask) {
				if(joy & mask) {
					if(rep[i] != 0xff) rep[i]++;
					if(rep[i] >= QUICK_REPEAT_DELAY) joy |= mask << 8; /* TRG_* */
				} else {
					rep[i] = 0;
				}
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	circle_fill
 ****************************************************************************/

/*{{/usr/PIECE/lib/src/simple/circle.cɂč쐬*/
/*
   circle_fill
   -1:ߐF 0-3:ʏF
*/
static void circle_fill(int x,int y,int r,int hv,int color)
{
  int f,xi=r,yi=0,xt=256,yt=256;
  if((r<0)||(r>32767))
    return;
  if(hv<0)
    return;
  if(hv<=256)
    yt=hv;
  else if(hv<=512)
    xt=512-hv;
  else
    return;
  f=-2*r+3;
  while(xi>=yi){
    int xh=xi*xt>>8;
    int yh=yi*yt>>8;
    fill(x+xh,y+yh,x-xh,y+yh,color);
    fill(x+xh,y-yh,x-xh,y-yh,color);
    xh=yi*xt>>8;
    yh=xi*yt>>8;
    fill(x+xh,y+yh,x-xh,y+yh,color);
    fill(x+xh,y-yh,x-xh,y-yh,color);
    if(f>=0){
      xi--;
      f-=4*xi;
    }
    yi++;
    f+=4*yi+2;
  }
}
/*}}/usr/PIECE/lib/src/simple/circle.cɂč쐬*/

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int x;
	int y;
	int c;

	/* \ݒB */
	dispmode(0,	/* 1:XvCg\/0:\ */
		 0,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 0,	/* 1:eLXgO/0:w */
		 1);	/* wiF(wʕ\Ȃ̂) */

	/* ^Cg\B */
	pspdisp(0, TITLE);

	/* XRA\B */
	x = 1;
	y = 1;
	symbolf(x, y, 0, 2, "1P:%06d", game.score * 10);
	symbolf(x, y, 0, 3, "1P:%6d" , game.score * 10);
	x = DISP_X - 5 * 9 - 2;
	y = 1;
	symbolf(x, y, 0, 2, "HI:%06d", hiscore * 10);
	symbolf(x, y, 0, 3, "HI:%6d" , hiscore * 10);

	for(;;) {
		schedule();
		if(joy & TRG_A) {
			return 0;
		}
		if(joy & TRG_SELECT) {
			return -1;
		}

		/* vvg\B */
		x = (DISP_X - 5 * 8) / 2 - 1;
		y = DISP_Y - 19;
		if(now % SEC(1) < SEC(0.66)) {
			c = 3;
		} else {
			c = -1;
		}
		symbolf(x, y, 0, c, " A START");
		y += 9;
		symbolf(x, y, 0, c, "SEL EXIT");
	}
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

static int
gen_test()
{
	int col;
	int row;
	CELL* cell1;
	CELL* cell2;
	int cnt;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell1 = &game.field[row][col];
			if(!cell1->type) {
				continue;
			}

			for(cnt = 0; col + cnt <= FIELD_COLS - 1; cnt++) {
				cell2 = &game.field[row][col + cnt];
				if(cell1->type != cell2->type) {
					break;
				}
			}
			if(cnt >= 3) {
				return 1;
			}
		}
	}

	for(col = 0; col < FIELD_COLS; col++) {
		for(row = 0; row < FIELD_ROWS; row++) {
			cell1 = &game.field[row][col];
			if(!cell1->type) {
				continue;
			}

			for(cnt = 0; row + cnt <= FIELD_ROWS - 1; cnt++) {
				cell2 = &game.field[row + cnt][col];
				if(cell1->type != cell2->type) {
					break;
				}
			}
			if(cnt >= 3) {
				return 1;
			}
		}
	}

	return 0;
}

void
game_init()
{
	int col;
	int row;
	CELL* cell;
	int retry1;
	int retry2;

	memset(&game, 0, sizeof game);

	game.timer = SEC(60);
	game.prev_timer = -1;

	//game.score = 0;
	game.prev_score = -1;

	//game.level = 0;
	game.prev_level = -1;

	//game.meter = 0;
	game.meter_full = 10; /*  */
	game.prev_meter = -1;

	//game.combo = 0;
	//game.combo_disp = 0;
	//game.prev_combo_disp = 0;
	//game.combo_disp_cnt = 0;

	game.cursor_color = 3;
	//game.cursor_blink = 0;
	game.cursor_col = (FIELD_COLS - 1) / 2;
	game.cursor_row = (FIELD_ROWS - 1) / 2;
	//game.prev_cursor_x = 0;
	//game.prev_cursor_y = 0;

	retry1 = 100;
L_RETRY1:
	memset(game.field, 0, sizeof game.field);
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			retry2 = 100;
L_RETRY2:
			cell->type = 1 + rnd(NUM_CELL_TYPES);
			if(gen_test()) {
				if(retry2) {
					retry2--;
					goto L_RETRY2;
				}
				if(retry1) {
					retry1--;
					goto L_RETRY1;
				}
				DIE();
			}
		}
	}

	field_disp_init();
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

static int
timer_down()
{
	if(game.timer) {
		game.timer--;
		switch(game.timer) {
		case SEC(10):
		case SEC( 9):
		case SEC( 8):
		case SEC( 7):
		case SEC( 6):
		case SEC( 5):
		case SEC( 4):
		case SEC( 3):
		case SEC( 2):
		case SEC( 1):
			sound(3);
			break;
		}
	}
	return game.timer;
}

void
game_main()
{
	int i;
	int j;
	int x;
	int y;
	int w;
	int h;
	int c;
	char* s;
	int stat;

	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */
		 0,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 0,	/* 1:eLXgO/0:w */
		 0);	/* wiF(wʕ\Ȃ̂) */

	/* Q[B */
	game_init();

	/* Q[JnB */
	for(j = 3; j >= 0; j--) {
		sound(3);
		field_disp();
		x = GO_X;
		y = GO_Y;
		w = GO_W;
		h = GO_H;
		switch(j) {
		case 0: s = "Go!"; x += 2;        break;
		case 1: s = "1"; x += 8; w -= 16; break;
		case 2: s = "2"; x += 8; w -= 16; break;
		case 3: s = "3"; x += 8; w -= 16; break;
		default: DIE();
		}
		symbol(x    , y    , s, 1, 3);
		symbol(x + 1, y    , s, 1, 3);
		symbol(x + 2, y    , s, 1, 3);
		symbol(x    , y + 1, s, 1, 3);
		symbol(x + 2, y + 1, s, 1, 3);
		symbol(x    , y + 2, s, 1, 3);
		symbol(x + 1, y + 2, s, 1, 3);
		symbol(x + 2, y + 2, s, 1, 3);
		for(i = 0; i < SEC(1); i++) {
			if(i < 3 * 2) {
				c = 3 - i / 2;
			} else if(i < SEC(1) - 3 * 2) {
				c = 0;
			} else {
				c = (i - (SEC(1) - 3 * 2)) / 2;
			}
			symbol(x + 1, y + 1, s, 1, c);
			schedule();
			if(joy & TRG_AB) {
				break;
			}
		}
		fill(x, y, x + w - 1, y + h - 1, -1);
	}
	field_disp();
	schedule();

	/* Q[B */
	for(;;) {
		game.cursor_color = 3;
		for(;;) {
			game.cursor_blink = 0; /*  =  */

			/* IB */
			for(;;) {
				for(;;) {
					schedule();
					if(!timer_down()) {
						goto L_GAMEOVER;
					}
					if(joy & PAD_AB) {
						break;
					}
					cursor_action1();
					field_disp();
					cursor_disp();
				}
				game.cursor_blink = 0; /*  =  */
				for(;;) {
					schedule();
					if(!timer_down()) {
						goto L_GAMEOVER;
					}
					if(!(joy & PAD_AB)) {
						break;
					}
					stat = cursor_action2();
					if(stat) {
						goto L_SWAP1;
					}
					field_disp();
					cursor_disp();
				}
				game.cursor_blink = SEC(0.3); /*  =  */
			}
L_SWAP1:
			game.cursor_blink = 0; /*  =  */

			/* OiB */
			for(i = 0; i < CELL_SIZE; i += 2) {
				schedule();
				timer_down();
				game.field_cnt = i;
				field_disp();
				cursor_disp();
			}

			/* ړB */
			move_done(stat);

			field_disp(); /* h~ */
			cursor_disp();

			/* ŔB */
			if(erase_test()) {
				break;
			}

			/* ߂B */
			stat = move_back(stat);

			/* ށB */
			for(i = 0; i < CELL_SIZE; i += 2) {
				schedule();
				timer_down();
				game.field_cnt = i;
				field_disp();
				cursor_disp();
			}

			/* ړB */
			move_done(stat);

			field_disp(); /* h~ */
			cursor_disp();
		}

		game.cursor_color = 2;
		do {
			game.cursor_blink = 0; /*  =  */

			/* ŁB */
			for(i = 0; i < NUM_FRUIT_PATTERNS + SEC(0.5); i++) {
				schedule();
				timer_down();
				game.field_cnt = i;
				cursor_action1();
				field_disp();
				cursor_disp();
			}

			/* ŊB */
			action_done();

			do {
				/* ړB */
				for(i = 0; i < CELL_SIZE; i += 2) {
					schedule();
					timer_down();
					game.field_cnt = i;
					cursor_action1();
					field_disp();
					cursor_disp();
				}

				/* ړB */
				action_done();

			/* ړB */
			} while(move_test());

		/* ŔB */
		} while(erase_test());
	}
L_GAMEOVER:
	sound(3);

	/* Q[I[o[B */
	field_disp();
	for(w = 0; w <= 24; w += 2) {
		schedule();
		for(i = 0; i < 4; i++) {
			for(j = 0; j < 3; j++) {
				x = 16 + 32 * i;
				y = 12 + 32 * j;
				circle_fill(x, y, w, 256, 0);
			}
		}
	}
	x = (DISP_X - 84) / 2;
	y = (DISP_Y - 10) / 2;
	for(i = 0; i < SEC(10); i++) {
		schedule();
		c = i / 3;
		if(c < 3) {
			symbol(x, y, "f`ld nudq", 0, c);
		} else {
			if(joy & TRG_AB) {
				break;
			}
		}
	}

	/* nCXRAXVB */
	if(game.score > hiscore) {
		hiscore = game.score;
	}
}

/****************************************************************************
 *	field_disp_init
 ****************************************************************************/

void
field_disp_init()
{
	int x1;
	int y1;
	int x2;
	int y2;

	/* wi̕sFœhׂ܂B */
	grcls(1);

	/* tB[hg`AFœhׂ܂B */
	x1 = FIELD_X - 3;
	y1 = FIELD_Y - 3;
	x2 = x1 + 84 - 1;
	y2 = y1 + 84 - 1;
	line(x1 + 3, y1    , x2 - 3, y1    , 3);
	line(x1 + 3, y2    , x2 - 3, y2    , 3);
	line(x1    , y1 + 3, x1    , y2 - 3, 3);
	line(x2    , y1 + 3, x2    , y2 - 3, 3);
	pset(x1 + 1, y1 + 1, 3);
	pset(x1 + 2, y1 + 1, 3);
	pset(x1 + 1, y1 + 2, 3);
	pset(x2 - 1, y1 + 1, 3);
	pset(x2 - 2, y1 + 1, 3);
	pset(x2 - 1, y1 + 2, 3);
	pset(x1 + 1, y2 - 1, 3);
	pset(x1 + 2, y2 - 1, 3);
	pset(x1 + 1, y2 - 2, 3);
	pset(x2 - 1, y2 - 1, 3);
	pset(x2 - 2, y2 - 1, 3);
	pset(x2 - 1, y2 - 2, 3);
	paint((x1 + x2) / 2, (y1 + y2) / 2, -1);

	/* [^[`܂B */
	x1 = 119;
	y1 =  11;
	x2 =  x1;
	y2 =  y1 + 61;
	circle(x1, y1, 3, 256, 3);
	paint(x1, y1, 3);
	circle(x1, y1, 2, 256, 2);
	paint(x1, y1, 2);
	circle(x2, y2, 7, 256, 3);
	paint(x2, y2, 3);
	circle(x2, y2, 6, 256, 2);
	paint(x2, y2, 2);
	fill(x1 - 3, y1, x1 + 3, y2 - 7, 3);
	fill(x1 - 2, y1, x1 + 2, y2 - 7, 2);
	circle(x2, y2 - 1, 4, 256, 1);
	paint(x2, y2 - 1, 1);
	circle(x2 - 1, y2, 2, 256, 0);
	paint(x2 - 1, y2, 0);
	fill(118, 64, 120, 66, 1);

	/* ԂȂǂ̃LvV\܂B */
	x1 = TIMER_X;
	y1 = TIMER_Y - 7;
	symbolf(x1, y1, 2, 3, "Timer:");
	x1 = SCORE_X;
	y1 = SCORE_Y - 7;
	symbolf(x1, y1, 2, 3, "Score:");
	x1 = LEVEL_X;
	y1 = LEVEL_Y - 7;
	symbolf(x1, y1, 2, 3, "Level:");
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp()
{
	int obj;
	int col;
	int row;
	CELL* cell;
	int x;
	int y;
	int w;
	int h;
	int cnt;
	int chr;
	int sec;
	int msec;

	/* tB[h\܂B */
	obj = 0;
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}

			x = FIELD_X + CELL_SIZE * col;
			y = FIELD_Y + CELL_SIZE * row;
			chr = ptn_fruit[cell->type - 1][0];

			switch(cell->stat) {
			case 0:
				/** no job **/
				break;

			case CELL_STAT_MOVE_LF:
				x = x + CELL_SIZE - game.field_cnt;
				break;

			case CELL_STAT_MOVE_RI:
				x = x - CELL_SIZE + game.field_cnt;
				break;

			case CELL_STAT_MOVE_DN:
				y = y - CELL_SIZE + game.field_cnt;
				break;

			case CELL_STAT_MOVE_UP:
				y = y + CELL_SIZE - game.field_cnt;
				break;

			case CELL_STAT_ERASE:
				cnt = game.field_cnt;
				if(cnt < NUM_FRUIT_PATTERNS) {
					chr = ptn_fruit[cell->type - 1][cnt];
				} else {
					cnt = cell->point;
					if(cnt > 9) {
						cnt = 0; /* ?? */
					}
					chr = ptn_point[cnt];
				}
				break;

			default:
				DIE();
			}

			obj = chdisp(obj, x, y, &chr_tbl[chr]);
		}
	}
	spcls(obj);

	/* ԂωĂA\܂B */
	if(game.timer != game.prev_timer) {
		game.prev_timer = game.timer;
		x = TIMER_X;
		y = TIMER_Y;
		w = TIMER_W;
		h = TIMER_H;
		fill(x, y, x + w - 1, y + h - 1, 1);
		sec  = game.timer / FPS;
		msec = game.timer % FPS * 1000 / FPS;
		symbolf(x, y, 2, 3, "%02d:%03d", sec, msec);
	}

	/* XRAωĂA\܂B */
	if(game.score != game.prev_score) {
		game.prev_score = game.score;
		x = SCORE_X;
		y = SCORE_Y;
		w = SCORE_W;
		h = SCORE_H;
		fill(x, y, x + w - 1, y + h - 1, 1);
		symbolf(x, y, 2, 3, "%6d", game.score * 10);
	}

	/* xωĂA\܂B */
	if(game.level != game.prev_level) {
		game.prev_level = game.level;
		x = LEVEL_X;
		y = LEVEL_Y;
		w = LEVEL_W;
		h = LEVEL_H;
		fill(x, y, x + w - 1, y + h - 1, 1);
		symbolf(x, y, 2, 3, "%6d", game.level + 1);
	}

	/* [^[ωĂA\܂B */
	if(game.meter != game.prev_meter) {
		game.prev_meter = game.meter;
		x = METER_X;
		y = METER_Y;
		w = METER_W;
		h = METER_H * game.meter / game.meter_full;
		if(h < 1) {
			h = 1;
		}
		if(h > METER_H) {
			h = METER_H;
		}
		fill(x, y, x + w - 1, y + (METER_H - h) - 1, 2);
		y += METER_H - h;
		fill(x, y, x + w - 1, y +            h  - 1, 1);
		pset(x    , y, 2);
		pset(x + 2, y, 2);
	}

	/* R{\܂B */
	if(game.combo_disp != game.prev_combo_disp) {
		game.prev_combo_disp = game.combo_disp;
		x = COMBO_X;
		y = COMBO_Y;
		w = COMBO_W;
		h = COMBO_H;
		fill(x, y, x + w - 1, y + h - 1, 1);
		if(game.combo_disp) {
			game.combo_disp_cnt = SEC(2); /*  */
			if(game.combo_disp <= 9) {
				symbolf(x, y, 2, 3, "%dMatch", game.combo_disp);
			} else {
				symbolf(x, y, 2, 3, "?Match");
			}
			y += 7;
			symbolf(x, y, 2, 3, "Combo");
		}
	}
	if(game.combo_disp_cnt) {
		game.combo_disp_cnt--;
		if(!game.combo_disp_cnt) {
			game.combo_disp = 0;
		}
	}
}

/****************************************************************************
 *	cursor_disp
 ****************************************************************************/

void
cursor_disp()
{
	int x;
	int y;

	/* J[\\܂B */
	if(game.prev_cursor_x ||
	   game.prev_cursor_y) {
		fill(game.prev_cursor_x - 1, game.prev_cursor_y - 1,
		     game.prev_cursor_x + 8, game.prev_cursor_y + 8, -1);
		game.prev_cursor_x = 0;
		game.prev_cursor_y = 0;
	}
	//
	if(game.cursor_blink < SEC(0.3)) {
		x = FIELD_X + CELL_SIZE * game.cursor_col;
		y = FIELD_Y + CELL_SIZE * game.cursor_row;
		if(game.cursor_color == 3) {
			switch(game.field[game.cursor_row][game.cursor_col].stat) {
			case CELL_STAT_MOVE_LF:
				x = x + CELL_SIZE - game.field_cnt;
				break;
			case CELL_STAT_MOVE_RI:
				x = x - CELL_SIZE + game.field_cnt;
				break;
			case CELL_STAT_MOVE_DN:
				y = y - CELL_SIZE + game.field_cnt;
				break;
			case CELL_STAT_MOVE_UP:
				y = y + CELL_SIZE - game.field_cnt;
				break;
			}
		}
		fill(x - 1, y - 1, x + 8, y + 8, game.cursor_color);
		fill(x    , y    , x + 7, y + 7, -1);
		game.prev_cursor_x = x;
		game.prev_cursor_y = y;
	}
}

/****************************************************************************
 *	cursor_action1
 ****************************************************************************/

void
cursor_action1()
{
	if((joy & TRG_LF) && (game.cursor_col > 0)) {
		game.cursor_col--;
		game.cursor_blink = 0; /*  =  */
		sound(1);
		return;
	}
	if((joy & TRG_RI) && (game.cursor_col < FIELD_COLS - 1)) {
		game.cursor_col++;
		game.cursor_blink = 0; /*  =  */
		sound(1);
		return;
	}
	if((joy & TRG_UP) && (game.cursor_row > 0)) {
		game.cursor_row--;
		game.cursor_blink = 0; /*  =  */
		sound(1);
		return;
	}
	if((joy & TRG_DN) && (game.cursor_row < FIELD_ROWS - 1)) {
		game.cursor_row++;
		game.cursor_blink = 0; /*  =  */
		sound(1);
		return;
	}

	if(++game.cursor_blink >= SEC(0.5)) { /* Őis */
		game.cursor_blink = 0;
	}
}

/****************************************************************************
 *	cursor_action2
 ****************************************************************************/

int
cursor_action2()
{
	CELL c1;
	CELL c2;

	if((joy & TRG_LF) && (game.cursor_col > 0)) {
		c1 = game.field[game.cursor_row][game.cursor_col    ];
		c2 = game.field[game.cursor_row][game.cursor_col - 1];
		if(!c1.type || c1.stat) DIE();
		if(!c2.type || c2.stat) DIE();
		c1.stat = CELL_STAT_MOVE_LF;
		c2.stat = CELL_STAT_MOVE_RI;
		game.field[game.cursor_row][game.cursor_col    ] = c2;
		game.field[game.cursor_row][game.cursor_col - 1] = c1;
		game.cursor_col--;
		sound(1);
		return CELL_STAT_MOVE_LF;
	}
	if((joy & TRG_RI) && (game.cursor_col < FIELD_COLS - 1)) {
		c1 = game.field[game.cursor_row][game.cursor_col    ];
		c2 = game.field[game.cursor_row][game.cursor_col + 1];
		if(!c1.type || c1.stat) DIE();
		if(!c2.type || c2.stat) DIE();
		c1.stat = CELL_STAT_MOVE_RI;
		c2.stat = CELL_STAT_MOVE_LF;
		game.field[game.cursor_row][game.cursor_col    ] = c2;
		game.field[game.cursor_row][game.cursor_col + 1] = c1;
		game.cursor_col++;
		sound(1);
		return CELL_STAT_MOVE_RI;
	}
	if((joy & TRG_UP) && (game.cursor_row > 0)) {
		c1 = game.field[game.cursor_row    ][game.cursor_col];
		c2 = game.field[game.cursor_row - 1][game.cursor_col];
		if(!c1.type || c1.stat) DIE();
		if(!c2.type || c2.stat) DIE();
		c1.stat = CELL_STAT_MOVE_UP;
		c2.stat = CELL_STAT_MOVE_DN;
		game.field[game.cursor_row    ][game.cursor_col] = c2;
		game.field[game.cursor_row - 1][game.cursor_col] = c1;
		game.cursor_row--;
		sound(1);
		return CELL_STAT_MOVE_UP;
	}
	if((joy & TRG_DN) && (game.cursor_row < FIELD_ROWS - 1)) {
		c1 = game.field[game.cursor_row    ][game.cursor_col];
		c2 = game.field[game.cursor_row + 1][game.cursor_col];
		if(!c1.type || c1.stat) DIE();
		if(!c2.type || c2.stat) DIE();
		c1.stat = CELL_STAT_MOVE_DN;
		c2.stat = CELL_STAT_MOVE_UP;
		game.field[game.cursor_row    ][game.cursor_col] = c2;
		game.field[game.cursor_row + 1][game.cursor_col] = c1;
		game.cursor_row++;
		sound(1);
		return CELL_STAT_MOVE_DN;
	}

	return 0;
}

/****************************************************************************
 *	move_back
 ****************************************************************************/

int
move_back(int stat)
{
	CELL c1;
	CELL c2;

	switch(stat) {
	case CELL_STAT_MOVE_LF:
		c1 = game.field[game.cursor_row][game.cursor_col    ];
		c2 = game.field[game.cursor_row][game.cursor_col + 1];
		if(!c1.type || c1.stat) DIE();
		if(!c2.type || c2.stat) DIE();
		c1.stat = CELL_STAT_MOVE_RI;
		c2.stat = CELL_STAT_MOVE_LF;
		game.field[game.cursor_row][game.cursor_col    ] = c2;
		game.field[game.cursor_row][game.cursor_col + 1] = c1;
		game.cursor_col++;
		return CELL_STAT_MOVE_RI;
	case CELL_STAT_MOVE_RI:
		c1 = game.field[game.cursor_row][game.cursor_col    ];
		c2 = game.field[game.cursor_row][game.cursor_col - 1];
		if(!c1.type || c1.stat) DIE();
		if(!c2.type || c2.stat) DIE();
		c1.stat = CELL_STAT_MOVE_LF;
		c2.stat = CELL_STAT_MOVE_RI;
		game.field[game.cursor_row][game.cursor_col    ] = c2;
		game.field[game.cursor_row][game.cursor_col - 1] = c1;
		game.cursor_col--;
		return CELL_STAT_MOVE_LF;
	case CELL_STAT_MOVE_UP:
		c1 = game.field[game.cursor_row    ][game.cursor_col];
		c2 = game.field[game.cursor_row + 1][game.cursor_col];
		if(!c1.type || c1.stat) DIE();
		if(!c2.type || c2.stat) DIE();
		c1.stat = CELL_STAT_MOVE_DN;
		c2.stat = CELL_STAT_MOVE_UP;
		game.field[game.cursor_row    ][game.cursor_col] = c2;
		game.field[game.cursor_row + 1][game.cursor_col] = c1;
		game.cursor_row++;
		return CELL_STAT_MOVE_DN;
	case CELL_STAT_MOVE_DN:
		c1 = game.field[game.cursor_row    ][game.cursor_col];
		c2 = game.field[game.cursor_row - 1][game.cursor_col];
		if(!c1.type || c1.stat) DIE();
		if(!c2.type || c2.stat) DIE();
		c1.stat = CELL_STAT_MOVE_UP;
		c2.stat = CELL_STAT_MOVE_DN;
		game.field[game.cursor_row    ][game.cursor_col] = c2;
		game.field[game.cursor_row - 1][game.cursor_col] = c1;
		game.cursor_row--;
		return CELL_STAT_MOVE_UP;
	default:
		DIE();
	}
}

/****************************************************************************
 *	move_done
 ****************************************************************************/

void
move_done(int stat)
{
	CELL* cell1;
	CELL* cell2;

	switch(stat) {
	case CELL_STAT_MOVE_LF:
		cell1 = &game.field[game.cursor_row][game.cursor_col    ];
		cell2 = &game.field[game.cursor_row][game.cursor_col + 1];
		if(!cell1->type || (cell1->stat != CELL_STAT_MOVE_LF)) DIE();
		if(!cell2->type || (cell2->stat != CELL_STAT_MOVE_RI)) DIE();
		cell1->stat = 0;
		cell2->stat = 0;
		break;
	case CELL_STAT_MOVE_RI:
		cell1 = &game.field[game.cursor_row][game.cursor_col    ];
		cell2 = &game.field[game.cursor_row][game.cursor_col - 1];
		if(!cell1->type || (cell1->stat != CELL_STAT_MOVE_RI)) DIE();
		if(!cell2->type || (cell2->stat != CELL_STAT_MOVE_LF)) DIE();
		cell1->stat = 0;
		cell2->stat = 0;
		break;
	case CELL_STAT_MOVE_UP:
		cell1 = &game.field[game.cursor_row    ][game.cursor_col];
		cell2 = &game.field[game.cursor_row + 1][game.cursor_col];
		if(!cell1->type || (cell1->stat != CELL_STAT_MOVE_UP)) DIE();
		if(!cell2->type || (cell2->stat != CELL_STAT_MOVE_DN)) DIE();
		cell1->stat = 0;
		cell2->stat = 0;
		break;
	case CELL_STAT_MOVE_DN:
		cell1 = &game.field[game.cursor_row    ][game.cursor_col];
		cell2 = &game.field[game.cursor_row - 1][game.cursor_col];
		if(!cell1->type || (cell1->stat != CELL_STAT_MOVE_DN)) DIE();
		if(!cell2->type || (cell2->stat != CELL_STAT_MOVE_UP)) DIE();
		cell1->stat = 0;
		cell2->stat = 0;
		break;
	default:
		DIE();
	}
}

/****************************************************************************
 *	erase_test
 ****************************************************************************/

int
erase_test()
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell1;
	CELL* cell2;
	int cnt;
	int point;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell1 = &game.field[row][col];
			if(!cell1->type) {
				DIE();
			}

			for(cnt = 0; col + cnt <= FIELD_COLS - 1; cnt++) {
				cell2 = &game.field[row][col + cnt];
				if(cell1->type != cell2->type) {
					break;
				}
			}
			if(cnt >= 3) {
				game.meter += (cnt - 2);
				point = game.combo + (cnt - 2);
				for(cnt = 0; col + cnt <= FIELD_COLS - 1; cnt++) {
					cell2 = &game.field[row][col + cnt];
					if(cell1->type != cell2->type) {
						break;
					}
					cell2->stat = CELL_STAT_ERASE;
					if(point > cell2->point) { /* c̏ꍇ́A_̍ */
						game.score += (point - cell2->point);
						cell2->point = point;
					}
				}
				col += cnt;
				active = 1;
			}
		}
	}

	for(col = 0; col < FIELD_COLS; col++) {
		for(row = 0; row < FIELD_ROWS; row++) {
			cell1 = &game.field[row][col];
			if(!cell1->type) {
				DIE();
			}

			for(cnt = 0; row + cnt <= FIELD_ROWS - 1; cnt++) {
				cell2 = &game.field[row + cnt][col];
				if(cell1->type != cell2->type) {
					break;
				}
			}
			if(cnt >= 3) {
				game.meter += (cnt - 2);
				point = game.combo + (cnt - 2);
				for(cnt = 0; row + cnt <= FIELD_ROWS - 1; cnt++) {
					cell2 = &game.field[row + cnt][col];
					if(cell1->type != cell2->type) {
						break;
					}
					cell2->stat = CELL_STAT_ERASE;
					if(point > cell2->point) { /* c̏ꍇ́A_̍ */
						game.score += (point - cell2->point);
						cell2->point = point;
					}
				}
				row += cnt;
				active = 1;
			}
		}
	}

	if(active) {
		game.combo++;
		if(game.combo >= 2) {
			game.combo_disp = game.combo;
		}

		/* xAbvB */
		if(game.meter >= game.meter_full) {
			do {
				game.level++;
				game.timer = SEC(60);
				game.meter -= game.meter_full;
				game.meter_full += 2; /*  */
			} while(game.meter >= game.meter_full);
			sound(0);
		} else {
			sound(2);
		}
	} else {
		game.combo = 0;
	}

	return active;
}

/****************************************************************************
 *	move_test
 ****************************************************************************/

int
move_test()
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = FIELD_COLS / 2 - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->type) {
				if(col > 0) {
					memcpy(cell, cell - 1,    sizeof(CELL));
					memset(      cell - 1, 0, sizeof(CELL));
				} else {
					memset(cell, 0, sizeof(CELL));
					cell->type = 1 + rnd(NUM_CELL_TYPES);
				}
				cell->stat = CELL_STAT_MOVE_RI;
				active = 1;
			}
		}
		for(col = FIELD_COLS / 2; col <= FIELD_COLS - 1; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				if(col < FIELD_COLS - 1) {
					memcpy(cell, cell + 1,    sizeof(CELL));
					memset(      cell + 1, 0, sizeof(CELL));
				} else {
					memset(cell, 0, sizeof(CELL));
					cell->type = 1 + rnd(NUM_CELL_TYPES);
				}
				cell->stat = CELL_STAT_MOVE_LF;
				active = 1;
			}
		}
	}

	return active;
}

/****************************************************************************
 *	action_done
 ****************************************************************************/

void
action_done()
{
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}

			switch(cell->stat) {
			case 0:
				/** no job **/
				break;

			case CELL_STAT_MOVE_LF:
			case CELL_STAT_MOVE_RI:
			case CELL_STAT_MOVE_UP:
			case CELL_STAT_MOVE_DN:
				cell->stat = 0;
				break;

			case CELL_STAT_ERASE:
				memset(cell, 0, sizeof(CELL));
				break;

			default:
				DIE();
			}
		}
	}
}

